计蒜客 AC Challenge (2018 ICPC亚洲区域赛网络赛 南京 E)(状压DP)

版权声明:Why is everything so heavy? https://blog.csdn.net/lzc504603913/article/details/82290576

题目链接:https://nanti.jisuanke.com/t/30994

Dlsj is competing in a contest with n (0 < n \le 20)n(0<n≤20) problems. And he knows the answer of all of these problems.

However, he can submit ii-th problem if and only if he has submitted (and passed, of course) s_isi​ problems, the p_{i, 1}pi,1​-th, p_{i, 2}pi,2​-th, ......, p_{i, s_i}pi,si​​-th problem before.(0 < p_{i, j} \le n,0 < j \le s_i,0 < i \le n)(0<pi,j​≤n,0<j≤si​,0<i≤n) After the submit of a problem, he has to wait for one minute, or cooling down time to submit another problem. As soon as the cooling down phase ended, he will submit his solution (and get "Accepted" of course) for the next problem he selected to solve or he will say that the contest is too easy and leave the arena.

"I wonder if I can leave the contest arena when the problems are too easy for me."
"No problem."
—— CCF NOI Problem set

If he submits and passes the ii-th problem on tt-th minute(or the tt-th problem he solve is problem ii), he can get t \times a_i + b_it×ai​+bi​ points. (|a_i|, |b_i| \le 10^9)(∣ai​∣,∣bi​∣≤109).

Your task is to calculate the maximum number of points he can get in the contest.

Input

The first line of input contains an integer, nn, which is the number of problems.

Then follows nn lines, the ii-th line contains s_i + 3si​+3 integers, a_i,b_i,s_i,p_1,p_2,...,p_{s_i}ai​,bi​,si​,p1​,p2​,...,psi​​as described in the description above.

Output

Output one line with one integer, the maximum number of points he can get in the contest.

Hint

In the first sample.

On the first minute, Dlsj submitted the first problem, and get 1 \times 5 + 6 = 111×5+6=11 points.

On the second minute, Dlsj submitted the second problem, and get 2 \times 4 + 5 = 132×4+5=13 points.

On the third minute, Dlsj submitted the third problem, and get 3 \times 3 + 4 = 133×3+4=13 points.

On the forth minute, Dlsj submitted the forth problem, and get 4 \times 2 + 3 = 114×2+3=11 points.

On the fifth minute, Dlsj submitted the fifth problem, and get 5 \times 1 + 2 = 75×1+2=7 points.

So he can get 11+13+13+11+7=5511+13+13+11+7=55 points in total.

In the second sample, you should note that he doesn't have to solve all the problems.

样例输入1复制

5
5 6 0
4 5 1 1
3 4 1 2
2 3 1 3
1 2 1 4

样例输出1复制

55

样例输入2复制

1
-100 0 0

样例输出2复制

0

题目来源

ACM-ICPC 2018 南京赛区网络预赛

题意:有很多道问题,在做某一道题前,要先完成某些题目,做出一道题会得到一个分数,可能是负数,分数跟做出这道题的时间有关。求能得到的最大分数。

解题思路:很容易陷入网络流,但是根本建不出图,观察题目发现N=20,容易想到暴力,但是拓扑排序不好做,因此想到状压DP。枚举每一种状态,假设现在状态为  1110100,那么就是现在做出了1235号题。这个状态可以由

1110000

1100100

1010000

0110100

这四种状态转移过来,转移过来的时候,分数就很好算了。因为你知道有多少1,就相当于是做出第几道题目。

关于状态到底能不能转移过来,就按照题目要求,用位运算判断一下就好了。

#include<iostream>
#include<queue>
#include<string.h>
#include<functional>
using namespace std;
typedef long long ll;
const int MAXN=1<<21;
const ll INF=1e18;
ll dp[MAXN];
ll qian[MAXN],a[MAXN],b[MAXN];

ll count(ll x){
    ll num=0;
    for (int j=0;j<25;j++)
        if (x&(1<<j)) num++;
    return num;
}

int main(){

    int N,M;
    scanf("%d",&N);
    for(int i=1;i<=N;i++){
        scanf("%lld%lld%d",&a[i],&b[i],&M);
        qian[i]=0;
        for(int j=0;j<M;j++){
            int k;
            scanf("%d",&k);
            qian[i]+=(1<<(k-1));//做出这道题前,要先做哪些题
        }
    }

    ll ans=0;
    for(int i=0;i<=(1<<N)-1;i++)
        dp[i]=-INF;
    dp[0]=0;
    for(int i=1;i<=(1<<N)-1;i++){
        for(int j=0;j<N;j++){
            if(i&(1<<j))//枚举子集
            {
                int u=i-(1<<j);
                if((u&qian[j+1])==qian[j+1])//如果满足转移要求,则转移
                {
                    ll w=dp[u]+count(i)*a[j+1]+b[j+1];
                    dp[i]=max(dp[i],w);
                    ans=max(ans,dp[i]);
                }
            }
        }
    }
    printf("%lld\n",ans);

    return 0;
}

猜你喜欢

转载自blog.csdn.net/lzc504603913/article/details/82290576
今日推荐